#include "demand.h"
#include <iostream>
#include <fstream>
#include <math.h>


Demand::Demand(double initial_demand) {
	demand = new double[52];
	//demand-profile given by a*x^2 + b*x + c, where x is stages from 0 to 51
	double a = 0.00072;
	double b = -0.038;
	double c = 1;
	double pi = 3.141592653589793238463;
	for (int i = 0; i < 52; i++){
		demand[i] = initial_demand * (0.25*cos(i*2*pi/52) + 0.75);
	}
}

void Demand::PrintDemand(int num_stages) {
	std::ofstream log;
	log.open("../../output/demand.txt");
	if (num_stages > 52){
		num_stages = 52;
	}
	for (int i = 0; i < num_stages - 1; i ++){
		log << demand[i] << " ";
	}
	log << demand[num_stages - 1] << std::endl;
	log.close();
}