/*
 * =====================================================================================
 *
 *       Filename:  hydromodule.cpp
 *    Description:  

 *        Created:  2010-07-15 09:56:12
 *         Author:  Arild Helseth 
 *
 * =====================================================================================
 */

#include "hydromodule.h"
#include "powerplant.h"

HydroModule::HydroModule(int inNr,Reservoir& inReservoir,PowerPlant& inPowerPlant)
   :Nr(inNr),MyReservoir(inReservoir),MyPowerPlant(inPowerPlant)
{
	DownStreamModule = NULL;
	potential_energy_factor = 0.0;
}

void HydroModule::setDownStreamModule(HydroModule* inModule)
{
   DownStreamModule = inModule;
   potential_energy_factor += inModule->getPowerPlant().getEfficiency();
}

void HydroModule::setUpStreamModules(HydroModule* inModule)
{
   UpStreamModules.push_back(inModule);
}