/*
 * =====================================================================================
 *
 *       Filename:  hydromodule.h
 *    Description:  

 *        Created:  2010-07-15 09:56:19
 *         Author:  Arild Helseth 
 *
 * =====================================================================================
 */
#ifndef HYDROMODULE_H
#define HYDROMODULE_H
#include <vector>

class Reservoir;
class PowerPlant;

class HydroModule
{
   private:
      int Nr;
      Reservoir& MyReservoir;
      PowerPlant& MyPowerPlant;
      std::vector<HydroModule*> UpStreamModules;
      HydroModule* DownStreamModule;
	  double potential_energy_factor;

   public:
      HydroModule(int inNr, Reservoir& inReservoir, PowerPlant& inPowerPlant);
      void setDownStreamModule(HydroModule*);
      void setUpStreamModules(HydroModule*);
      Reservoir& getReservoir() const {return MyReservoir;}
      PowerPlant& getPowerPlant() const {return MyPowerPlant;}
      std::vector<HydroModule*> getUpStreamModules() {return UpStreamModules;}
      int getNr() const {return Nr;}
};
#endif
