#include "input.h"
#include <iostream>
#include <fstream>
#include <sstream>
#include "convertstring.h"

void Input::Initialize(char* argv[]) {
	num_stages = convertString<int>(argv[1]);
	num_branches = convertString<int>(argv[2]);
	num_samples = convertString<int>(argv[3]);
	min_new_cuts = convertString<int>(argv[4]);
	num_substages = convertString<int>(argv[5]);
	initial_demand = convertString<int>(argv[6]);
	should_print = convertString<bool>(argv[7]);
	use_relaxation = convertString<bool>(argv[8]);
	num_simulations = convertString<int>(argv[9]);
	max_num_iterations = convertString<int>(argv[10]);
	initial_reservoir = convertString<double>(argv[11]);
	should_print_send_log = convertString<double>(argv[12]);
	should_print_time_data = convertString<double>(argv[13]);
}

void Input::Initialize(std::ifstream& data) {
	std::string token;
	bool stages = true;
	bool branches = true;
	bool samples = true;
	bool in_min_new_cuts = true;
	bool substages = true;
	bool init_demand = true;
	bool in_should_print = true;
	bool in_use_relaxation = true;
	bool in_num_simulations = true;
	bool in_max_num_iterations = true;
	bool in_initial_reservoir = true;
	bool in_should_print_send_log = true;
	bool in_should_print_time_data = true;

	while (data >> token) {
		if (token == "#") {
			data.ignore(80,'\n');
		}
		else if (stages) {
			num_stages = convertString<int>(token);
			stages = false;
		}
		else if (branches) {
			num_branches = convertString<int>(token);
			branches = false;
		}
		else if (samples) {
			num_samples = convertString<int>(token);
			samples = false;
		}
		else if (in_min_new_cuts) {
			min_new_cuts = convertString<int>(token);
			in_min_new_cuts = false;
		}
		else if (substages){
			num_substages = convertString<int>(token);
			substages = false;
		}
		else if (init_demand){
			initial_demand = convertString<int>(token);
			init_demand = false;
		}
		else if (in_should_print){
			should_print = convertString<bool>(token);
			in_should_print = false;
		}
		else if (in_use_relaxation){
			use_relaxation = convertString<bool>(token);
			in_use_relaxation = false;
		}
		else if (in_num_simulations){
			num_simulations = convertString<int>(token);
			in_num_simulations = false;
		}
		else if (in_max_num_iterations){
			max_num_iterations = convertString<int>(token);
			in_max_num_iterations = false;
		}
		else if (in_initial_reservoir){
			initial_reservoir = convertString<double>(token);
			in_initial_reservoir = false;
		}
		else if (in_should_print_send_log){
			should_print_send_log = convertString<bool>(token);
			in_should_print_send_log = false;
		}
		else if (in_should_print_time_data){
			should_print_time_data = convertString<bool>(token);
			in_should_print_time_data = false;
		}
	}
}

void Input::Print() {
	std::cout << num_stages << " stages, " << 
		         num_branches << " branches, " <<
				 num_samples << " samples, " <<
				 min_new_cuts << " min new cuts, " <<
				 num_substages << " substages, " <<
				 initial_demand << " demand, " <<
				 "max " << max_num_iterations << " iterations, " <<
				 initial_reservoir << " initial reservoir, " <<
				 std::endl;
}