#ifndef MYSIMPLEXSOLVER2_H
#define MYSIMPLEXSOLVER2_H
#include <vector>
#include <map>
#include "lp_lib.h"

class MySimplexSolver2
{
private:
	lprec* lp_model;
	int solution_error;
	int log_num;

	void LoadObjectiveFunction(double* , int);
	void LoadVariableBounds(int, double*, double*);
public:
	MySimplexSolver2();
	~MySimplexSolver2(){delete_lp(lp_model); };
	void InitialSolve();
	void Resolve();
	void Reset();
	void Reset(int num_variables);
	void LoadProblem(int, std::vector< std::map<int, double> >& , double*, double*, double*, double*, double*);
	void SetRowBounds(int constraint, double lower_bound, double upper_bound);
	double* GetColSolution();
	double* GetRowPrice();
	double GetObjectiveValue(){return get_working_objective(lp_model); };
	double GetInfinity(){return get_infinite(lp_model); };
	bool IsProvenOptimal(){return (solution_error == 0); };
	void WriteLP(const char* file);
	void PrintSolution(const char* File);
};

#endif