#ifndef MYSIMPLEXSOLVERCOINCLP_H
#define MYSIMPLEXSOLVERCOINCLP_H
#include <vector>
#include <map>
#include "OsiClpSolverInterface.hpp"
#include "CoinPackedMatrix.hpp"
#include "cut.h"

class MySimplexSolverCoinCLP{
private:
	OsiClpSolverInterface * lp_model;
	CoinPackedMatrix * matrix;

	void ConvertToCoinPackedMatrix( std::vector< std::map<int, double> >& );
public:
	MySimplexSolverCoinCLP();
	~MySimplexSolverCoinCLP(){delete matrix; delete lp_model; };
	bool InitialSolve();
	bool Resolve();
	void Reset();
	void Reset(int num_variables);
	void LoadProblem(int, std::vector< std::map<int, double> >& , double*, double*, double*, double*, double*);
	void SetRowBounds(int constraint, double lower_bound, double upper_bound);
	const double* GetColSolution(){return lp_model->getColSolution(); };
	const double* GetRowPrice(){return lp_model->getRowPrice(); };
	double GetObjectiveValue(){return lp_model->getObjValue(); };
	double GetInfinity(){return lp_model->getInfinity(); };
	bool IsProvenOptimal(){return lp_model->isProvenOptimal(); };
	void WriteLP(const char* file){lp_model->writeLp(file, "lp", 0.001, 10, 6, 1.0, false); };
	void PrintSolution(const char* file);
	bool isOptimal();
	void AddCut(Cut*, int*, double, int);
};

#endif