/*
 * =====================================================================================
 *
 *       Filename:  reservoir.h
 *    Description:  

 *        Created:  2010-07-15 09:07:23
 *         Author:  Arild Helseth 
 *
 * =====================================================================================
 */
#ifndef RESERVOIR_H
#define RESERVOIR_H

#include <vector>

class Reservoir
{
   private:
      int ModuleNr;
      double Capacity;
      double Initial;
	  double yearly_inflow;
      std::vector<double*> Inflow;


   public:
      Reservoir(int inModuleNr,double inCapacity,double inInitial, double in_yearly_inflow);
      int getModuleNr() const {return ModuleNr;}
      double getCapacity() const {return Capacity;}
      double getInitial() const {return Initial;}
	  double get_yearly_inflow() {return yearly_inflow;}
      void addInflowElement(double* di) {Inflow.push_back(di);}
      double getInflowElement(int i) const {return *(Inflow[i]);}


};
#endif

