#ifndef STATE_H
#define STATE_H
#include "stagedata.h"
#include <vector>

struct State{
	int branch;
	int stage;
	StageData* stage_data;
	State* previous_state;
	State* next_state;
	State** branches;
	int tag; // unique identifier used for message passing, on the form 1iiibbbsss , where bbb is branch and sss is stage. 1001013 means branch 1 stage 13, iii is used for iteration number.

	double* initial_reservoir;
	double* previous_inflow; 

	double relative_inflow;
	double* inflow;
	double demand;
	int num_variables;
	int num_constraints;

	double* solution;
	double* reservoir_solution;
	double* outflow;
	double* spillage;
	double objective_value;
	double future_cost;
	double current_cost;

	std::ofstream log;

	State(int in_branch, int in_stage, StageData* in_stage_data, State* in_previous_state)
		:branch(in_branch), stage(in_stage), stage_data(in_stage_data), previous_state(in_previous_state){};

};

#endif